
#include "mydebug.h"


asm char *stackptr();

asm char *stackptr()
{
//	long tmp;
//
//	stw r1,tmp
//	lwz	r3,tmp
//	blr

	srawi	r3,r1,0
	blr
}

void prepstack()
{
	thread_id	thread;
	thread_info	info;
	long	*ptr;
	long	*base;

	thread=find_thread(NULL);
	get_thread_info(thread,&info);
	
	ptr=(long*)stackptr();
	base=(long*)info.stack_base;
	while(--ptr >= &base[1024])
	{
		*ptr = 0xdeadbeef;
	}
	printf("thread: %d\n  stack base: %08x\n  stack ptr:  %08x\n  stack end:  %08x\n",
			info.thread,info.stack_base,stackptr(),info.stack_end);
}


void checkstack()
{
	thread_id	thread;
	thread_info	info;
	long	*base;
	long	*top;

	thread=find_thread(NULL);
	get_thread_info(thread,&info);
	base=&((long*)info.stack_base)[1024];
	top=(long*)info.stack_end;

	while(*base == 0xdeadbeef) base++;

	printf("stack used for thread %d: %d bytes\n",info.thread,(char*)top-(char*)base);
}



long countviews(BView *top)
{
	return viewnum(top,0)|(viewnest(top,0)<<16);
}


long viewnum(BView *top, long num)
{
	num++;

	if(top->CountChildren())
	{
		for(int i=0;i<top->CountChildren();i++)
			num=viewnum(top->ChildAt(i),num);
	}
	return num;
}

long viewnest(BView *top,long nest)
{
	long maxnest=nest+1;
	long tmpnest;

	if(top->CountChildren())
	{
		for(int i=0;i<top->CountChildren();i++)
		{
			tmpnest=viewnest(top->ChildAt(i),nest+1);
			if(tmpnest>maxnest)
				maxnest=tmpnest;
		}
	}
	return 	maxnest;
}
